#-*- coding:utf-8 -*-

import os.path as Path
import subprocess

from base import EnhacModule


class Maker(EnhacModule):
    def __init__(self, enhac):
        self.enhac = enhac

        d, f = Path.split(self.enhac.fname)
        self.enhac.fname_bin = Path.join(d, ".enhac_bin.%s" % f)

        self.cmd = None

    def f_make(self, cmd):
        if self.cmd is not None:
            self.enhac.pw_warning("Make command is redefined")
        self.cmd = tuple(cmd.split())

    def do_make(self):
        self.enhac.w_close()

        Includer = self.enhac.modules["Includer"]
        c_includes = [i[1] for i in Includer.includes if i[1]]

        make_cmd = list(self.cmd)

        cmd_incs = []
        cmd_incs.append(self.enhac.fname_out)
        cmd_incs.extend("-I%s" % inc_path for inc_path in Includer.include_paths)
        cmd_incs.extend(c_includes)

        cmd_out = ["-o%s" % self.enhac.fname_bin]

        make_cmd = replace_or_append(make_cmd, "%INCS%", cmd_incs)
        make_cmd = replace_or_append(make_cmd, "%OUT%", cmd_out)

        self.enhac.p_info("Making:")
        print "-" * 20
        print " ".join(make_cmd)
        print "-" * 20
        if subprocess.call(make_cmd):
            raise OSError("Compilation failed")

        self.enhac.safe_remove(self.enhac.fname_out)


def replace_or_append(lst, token, sublst):
    try:
        index = lst.index(token)
        return lst[:index] + sublst + lst[index+1:]
    except ValueError:
        return lst + sublst
